/*********************************************************************

          samplepscg.c: PolhemusSensor & CyberGlove device driver
                       sample program
                                        Kenji with Tail

*********************************************************************/


#include <stdio.h>
#include <math.h>

/* ؤäդΤ󤯤롼 */
#include "ps.h"
#include "cg.h"

/* ȤꤢߤʡǤäפä 38400ܡ */
#define BAUD 38400

/* УӤΤ󤵡ϡĤǤ */
#define PS1_TEST 1

/* СxΤäϡ */
#define CG_TEST 1

int main(void)
{
	int c, i, j, b;
	Angle_cg angle;
	PosOri_ps p1, p2, p3, p4;

	/* ݡȣ У Ҥ餯 */
	c = Init_ps("/dev/ttyd3", BAUD);
	printf("ps-init: %d\n", c);


	/* ǤդȤ station ΤߤƤ ͤΤᡣ */
#if PS1_TEST
	SetStation_ps(1, ON_PS);
#else
	SetStation_ps(1, ON_PS);
	SetStation_ps(2, ON_PS);
	SetStation_ps(3, ON_PS);
	SetStation_ps(4, ON_PS);
#endif

	/* ݡȣǡãǤҤ餯 */
#if CG_TEST
	c = Init_cg(1, "/dev/ttyd1", BAUD);
	printf("cg-init: %d\n", c);
	Light_cg(1, LIT_CG);
	c = Init_cg(2, "/dev/ttyd2", BAUD);
	printf("cg-init: %d\n", c);
#endif

	/* ʤɤߤƤߤ */
	for(i = 0; i < 99; i++){

		/* Request ȡƤ ʤĤäƤ */
#if PS1_TEST
		b = PosRequest_ps(p1, p2, p3, p4);
		printf("%d: = %f %f %f %f %f %f\n",b,p1[0],p1[1],p1[2],p1[3],p1[4],p1[5]);
#else
		/*  station#1 餹 && 餹-ܤON ʤ飱*/
		b = PosRequest_ps(p1, p2, p3, p4);
		printf("1: = %f %f %f *%d* ",p1[0],p1[1],p1[2],b);
		printf("2: = %f %f %f ",p2[0],p2[1],p2[2]);
		printf("3: = %f %f %f ",p3[0],p3[1],p3[2]);
		printf("4: = %f %f %f\n",p4[0],p4[1],p4[2]);
#endif

#if CG_TEST
		/* Request ȡΤɤchar ǤäƤ */
		b = Request_cg(1, angle);
		for(j = 0; j < 5 /* 18 */; j++){
			printf("%03d ", angle[j]);
		}
		printf("*%d* ", b);
		b = Request_cg(2, angle);
		for(j = 0; j < 5 ; j++){
			printf("%03d ", angle[j]);
		}
/*		printf("*%d* ", b);*/
#endif

	}

	/*  Ȥޤ礦 */
	Close_cg(1);
	Close_cg(2);
	return Close_ps();
}

